<!doctype html>
<!-- Note that adding an appcache really speeds things up after the first load
    You need to amend the appcache file to meet your needs.
    Don't forget to change the appcache file if you update ANY
    of the files in it otherwise the old versions will ALWAYS be used.
<html lang="en" manifest="./uibuilder.appcache">
-->
<html lang="en">
<!--
    This is the default, template html for uibuilder.
    It is meant to demonstrate the use of VueJS & bootstrap-vue to dynamically
    update the ui based on incoming/outgoing messages from/to the
    Node-RED server.

    You will want to alter this to suite your own needs. To do so,
    copy this file to <userDir>/uibuilder/<url>/src.
-->
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, minimum-scale=1, initial-scale=1, user-scalable=yes">

    <title>VizBlock Controller</title>
    <meta name="description" content="VizBlock Controller - control your VizBlock">

    <link rel="icon" href="./images/node-blue.ico">

    <!-- See https://goo.gl/OOhYW5 -->
    <link rel="manifest" href="./manifest.json">
    <meta name="theme-color" content="#3f51b5">

    <!-- Used if adding to homescreen for Chrome on Android. Fallback for manifest.json -->
    <meta name="mobile-web-app-capable" content="yes">
    <meta name="application-name" content="VizBlock Controller">

    <!-- Used if adding to homescreen for Safari on iOS -->
    <meta name="apple-mobile-web-app-capable" content="yes">
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
    <meta name="apple-mobile-web-app-title" content="VizBlock Controller">

    <!-- Homescreen icons for Apple mobile use if required
        <link rel="apple-touch-icon" href="./images/manifest/icon-48x48.png">
        <link rel="apple-touch-icon" sizes="72x72" href="./images/manifest/icon-72x72.png">
        <link rel="apple-touch-icon" sizes="96x96" href="./images/manifest/icon-96x96.png">
        <link rel="apple-touch-icon" sizes="144x144" href="./images/manifest/icon-144x144.png">
        <link rel="apple-touch-icon" sizes="192x192" href="./images/manifest/icon-192x192.png">
    -->

    <link type="text/css" rel="stylesheet" href="../uibuilder/vendor/bootstrap/dist/css/bootstrap.min.css" />
    <link type="text/css" rel="stylesheet" href="../uibuilder/vendor/bootstrap-vue/dist/bootstrap-vue.css" />
    
    <link rel="stylesheet" href="./index.css" media="all">
</head>
<body>
    <div id="app" v-cloak>
        <b-container id="app_container">
            <h1 style="text-align:center" class="pt-3 pb-3 text-light">
                VizBlock Controller
            </h1>
            <div>
                <b-form-select v-model="selected" :options="options" v-on:change="onChange(this.value)" size='lg'></b-form-select>
            </div>
            <div role="tablist" v-if="blockType != null">
                <b-button block href="#" v-b-toggle.accordion-1 variant="dark" class='mt-2' size='lg'>Test commands</b-button>
                <b-collapse id="accordion-1" accordion="my-accordion" role="tabpanel">
                    <b-form class="p-3 bg-light" @submit="onSubmit">
                        <p>Click the buttons below, or type and submit your own command.</p>
                        <p>
                            <div>
                              <b-button class='mr-3' variant="success" v-on:click="blockCommand('goto 0')" v-if="blockType == 'servo'">Go to 0°</b-button>
                              <b-button variant="danger" v-on:click="blockCommand('goto 170')" v-if="blockType == 'servo'">Go to 180°</b-button>
                            </div>
                        </p>
                        <p>
                            <div>
                              <b-button class='mr-3' variant="danger" v-on:click="blockCommand('red_leds 12')" v-if="blockType == 'pixel'">All red</b-button>
                              <b-button variant="success" v-on:click="blockCommand('green_leds 7')" v-if="blockType == 'pixel'">Half green</b-button>
                            </div>
                        </p>
         
                        <b-form-input
                          id="input-1"
                          v-model="textCommand"
                          required
                          placeholder="Type your command here..."
                        ></b-form-input>
                      <b-button class='mt-2' type="submit" variant="primary">Submit</b-button>
                    </b-form>
                </b-collapse>
                <b-button block href="#" v-b-toggle.accordion-2 variant="dark" class='mt-2' size='lg'>Set behaviour</b-button>
                  <b-collapse id="accordion-2" accordion="my-accordion" role="tabpanel">
                    <b-form class="p-3 bg-light">
                        <p>Your block is the <b>{{blockFeature}}</b> for <b>face {{face}}</b>. Decide how it will respond to different emotions.</p>
                        <div v-if="blockType == 'servo'">
                            <p>
                              <div>
                                <label for="range-1"><b>Set the angle for happyness:</b></label>
                                <b-form-input id="range-1" v-model="happy_angle" type="range" min="0" max="180" v-on:change="servoChange(this.value)"></b-form-input>
                                <div class="mt-1">Value: {{ happy_angle }} degrees</div>
                              </div>
                            </p>
                            <p>
                              <div>
                                <label for="range-2"><b>Set the angle for sadness:</b></label>
                                <b-form-input id="range-2" v-model="sad_angle" type="range" min="0" max="180" v-on:change="servoChange(this.value)"></b-form-input>
                                <div class="mt-1">Value: {{ sad_angle }} degrees</div>
                              </div>
                            </p>
                        </div>
                        <div v-if="blockType == 'pixel'">
                            <p>
                                <label for="colour-1"><b>Set the colour for happyness:</b></label>
                                <b-form-select id="colour-1" v-model="happy_colour" :options="colours" v-on:change="pixelChange(this.value)" size='lg'></b-form-select>
                            </p>
                            <p>
                              <div>
                                <label for="count-1"><b>Set the number of LEDs for happyness: {{ happy_count }}</b></label>
                                <b-form-input id="count-1" v-model="happy_count" type="range" min="1" max="12" v-on:change="pixelChange(this.value)"></b-form-input>
                              </div>
                            </p>
                            <p>
                                <label for="colour-2"><b>Set the colour for sadness:</b></label>
                                <b-form-select id="colour-2" v-model="sad_colour" :options="colours" v-on:change="pixelChange(this.value)" size='lg'></b-form-select>
                            </p>
                            <p>
                              <div>
                                <label for="count-2"><b>Set the number of LEDs for sadness: {{ sad_count }}</b></label>
                                <b-form-input id="count-2" v-model="sad_count" type="range" min="1" max="12" v-on:change="pixelChange(this.value)"></b-form-input>
                              </div>
                            </p>
                        </div>
        
                    </b-form>
                  </b-collapse>
            </div>
        </b-container>
    </div>

    <!-- These MUST be in the right order. Note no leading / -->
    <!-- REQUIRED: Socket.IO is loaded only once for all instances
                     Without this, you don't get a websocket connection -->
    <script src="../uibuilder/vendor/socket.io/socket.io.js"></script>

    <!-- --- Vendor Libraries - Load in the right order --- -->
    <script src="../uibuilder/vendor/vue/dist/vue.js"></script> <!-- dev version with component compiler -->
    <!-- <script src="../uibuilder/vendor/vue/dist/vue.min.js"></script>   prod version with component compiler -->
    <!-- <script src="../uibuilder/vendor/vue/dist/vue.runtime.min.js"></script>   prod version without component compiler -->
    <script src="../uibuilder/vendor/bootstrap-vue/dist/bootstrap-vue.js"></script>

    <!-- REQUIRED: Sets up Socket listeners and the msg object -->
    <!-- <script src="./uibuilderfe.js"></script>   //dev version -->
    <script src="./uibuilderfe.min.js"></script> <!--    //prod version -->
    <!-- OPTIONAL: You probably want this. Put your custom code here -->
    <script src="./index.js"></script>

</body>

</html>